(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("lodash-es/omit"), require("axios"), require("lodash-es/partial"), require("lodash-es/extend"));
	else if(typeof define === 'function' && define.amd)
		define(["lodash-es/omit", "axios", "lodash-es/partial", "lodash-es/extend"], factory);
	else if(typeof exports === 'object')
		exports["axiosCacheAdapter"] = factory(require("lodash-es/omit"), require("axios"), require("lodash-es/partial"), require("lodash-es/extend"));
	else
		root["axiosCacheAdapter"] = factory(root[undefined], root[undefined], root[undefined], root[undefined]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_0__, __WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_4__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_0__;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _axios = __webpack_require__(2);

var _axios2 = _interopRequireDefault(_axios);

var _partial = __webpack_require__(3);

var _partial2 = _interopRequireDefault(_partial);

var _extend = __webpack_require__(4);

var _extend2 = _interopRequireDefault(_extend);

var _omit = __webpack_require__(0);

var _omit2 = _interopRequireDefault(_omit);

var _readCache = __webpack_require__(5);

var _readCache2 = _interopRequireDefault(_readCache);

var _serialize = __webpack_require__(6);

var _serialize2 = _interopRequireDefault(_serialize);

var _memory = __webpack_require__(7);

var _memory2 = _interopRequireDefault(_memory);

var _exclude = __webpack_require__(8);

var _exclude2 = _interopRequireDefault(_exclude);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function setupCache() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  config.store = config.store || new _memory2.default();
  var key = config.key || function (req) {
    return req.url;
  };

  config.maxAge = config.maxAge || 0;
  config.readCache = config.readCache || _readCache2.default;
  config.serialize = config.serialize || _serialize2.default;
  config.clearOnStale = config.clearOnStale !== undefined ? config.clearOnStale : true;
  config.debug = config.debug || false;

  config.exclude = config.exclude || {};
  config.exclude.query = config.exclude.query || true;
  config.exclude.paths = config.exclude.paths || [];
  config.exclude.filter = config.exclude.filter || null;

  if (config.debug !== false) {
    config.debug = typeof config.debug === 'function' ? config.debug : console.log.bind(console);
  }

  function response(req, uuid, res) {
    var type = res.status / 100 | 0;

    // only cache 2xx response
    if (type !== 2) {
      return res;
    }

    // exclude binary response from cache
    if (['arraybuffer', 'blob'].indexOf(res.responseType) > -1) {
      return res;
    }

    var expires = config.maxAge === 0 ? 0 : Date.now() + config.maxAge;

    return config.store.setItem(uuid, { expires: expires, data: config.serialize(req, res) }).then(function () {
      return res;
    });
  }

  function request(req) {
    var uuid = key(req);
    var next = (0, _partial2.default)(response, req, uuid);

    if ((0, _exclude2.default)(req, config.exclude)) {
      return Promise.reject(next);
    }

    // clear cache if method different from GET.
    // We should exclude HEAD
    var method = req.method.toLowerCase();

    if (method === 'head') {
      return Promise.reject(next);
    }

    if (method !== 'get') {
      config.store.removeItem(uuid);
      return Promise.reject(next);
    }

    return config.store.getItem(uuid).then(function (value) {
      return config.readCache(req, config.debug)(value).then(function (data) {
        data.config = req;
        data.request = { fromCache: true };

        return data;
      }).catch(function (err) {
        // clean up cache if stale
        if (config.clearOnStale && err.reason === 'cache-stale') {
          return config.store.removeItem(uuid).then(function () {
            return Promise.reject(next);
          });
        }

        return Promise.reject(next);
      });
    });
  }

  function adapter(config) {
    return new Promise(function (resolve, reject) {
      return request(config).then(function (response) {
        return resolve(response);
      }).catch(function (response) {
        return _axios2.default.defaults.adapter(config).then(response).then(function (res) {
          return resolve(res);
        }).catch(function (err) {
          return reject(err);
        });
      });
    });
  }

  return {
    adapter: adapter,
    store: config.store
  };
}

var defaultOptions = {
  cache: {
    maxAge: 15 * 60 * 1000
  }
};

function setup(options) {
  options = (0, _extend2.default)({}, defaultOptions, options);

  var cache = setupCache(options.cache);
  var axiosOptions = (0, _omit2.default)(options, ['cache']);

  var request = _axios2.default.create((0, _extend2.default)({}, axiosOptions, { adapter: cache.adapter }));

  request.cache = cache;

  return request;
}

var lib = {
  setupCache: setupCache,
  setup: setup
};

exports.default = lib;

module.exports = lib;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_4__;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (req, log) {
  return function (value) {
    return new Promise(function (resolve, reject) {
      if (!value || !value.data) {
        log('cache-miss', req.url);
        var error = new Error();

        error.reason = 'cache-miss';
        error.message = 'Value not found from cache';
        return reject(error);
      }

      var expires = value.expires,
          data = value.data;


      if (expires !== 0 && expires < Date.now()) {
        log('cache-stale', req.url);
        var _error = new Error();

        _error.reason = 'cache-stale';
        _error.message = 'Value is stale';
        return reject(_error);
      }

      // // hydrate pseudo xhr from cached value
      // req.xhr = hydrate(data)
      //
      // // override request end callback
      // req.callback = (err, res) => {
      //   log('cache-hit', req.url)
      //
      //   if (err) {
      //     return reject(err, res)
      //   }
      //
      //   resolve(res)
      // }

      log('cache-hit', req.url);

      return resolve(data);
    });
  };
};

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = serialize;

var _omit = __webpack_require__(0);

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function serialize(req, res) {
  return (0, _omit2.default)(res, ['request', 'config']);
}

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MemoryStore = function () {
  function MemoryStore() {
    _classCallCheck(this, MemoryStore);

    this._store = {};
  }

  _createClass(MemoryStore, [{
    key: "getItem",
    value: function getItem(key) {
      return Promise.resolve(this._store[key] || null);
    }
  }, {
    key: "setItem",
    value: function setItem(key, value) {
      this._store[key] = value;
      return Promise.resolve(value);
    }
  }, {
    key: "clear",
    value: function clear() {
      this._store = {};
      return Promise.resolve();
    }
  }]);

  return MemoryStore;
}();

exports.default = MemoryStore;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exclude;
function exclude(req) {
  var exclusions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (typeof exclusions.filter === 'function' && !exclusions.filter(req)) {
    return true;
  }

  // do not cache request with query
  if (exclusions.query && req.url.match(/\?.*$/)) {
    return true;
  }

  var found = false;
  var paths = exclusions.paths || [];

  paths.forEach(function (regexp) {
    if (req.url.match(regexp)) {
      found = true;
      return found;
    }
  });

  if (found) {
    return true;
  }

  // All rules explained. fo not rewrite regexp.
  return false;
}

/***/ })
/******/ ]);
});
//# sourceMappingURL=cache.js.map